unit mdb;

interface

function    CreateDatabase(const Path: string; var Err: string): Boolean;
function    ChangePassword(const Path, OldPath, NewPass: string; var Err: string): Boolean;
function    CompactDatabase(const Path, Pass: string; var Err: string): Boolean;

implementation

uses
    Windows, SysUtils, ComObj, ActiveX, Variants;

//  ---------------------------------------------------------------------------
//  f[^x[X쐬
function    CreateDatabase(const Path: string; var Err: string): Boolean;
const
    CONN_STR = 'Provider=Microsoft.Jet.OLEDB.4.0;Data Source="%s"';
var
    Catalog: OleVariant;
    ConnStr: string;
begin
    Result := false;
    ConnStr := Format(CONN_STR, [Path]);
    try
        try
            Catalog := CreateOleObject('ADOX.Catalog');
            Catalog.Create(ConnStr);
        finally
            Catalog := Unassigned;
        end;
        Result := true;
    except
        on E:Exception do Err := E.Message;
    end;
end;

//  ---------------------------------------------------------------------------
//  pX[hݒEύX
function    ChangePassword(const Path, OldPath, NewPass: string; var Err: string): Boolean;
const
    CONN_STR = 'Data Source="%s";Jet OLEDB:Database Password=%s';
var
    Engine: OleVariant;
    Temp: string;
    S1, S2: string;
begin
    Result := false;
    //  kw
    Temp := ChangeFileExt(Path, '.bak');
    //  Ώ(Ă悢Ȃ)
    DeleteFile(Temp);
    //  ڑ񕗍쐬
    S1 := Format(CONN_STR, [Path, OldPath]);
    S2 := Format(CONN_STR, [Temp, NewPass]);
    try
        try
            //  
            Engine := CreateOleObject('JRO.JetEngine');
            Engine.CompactDatabase(S1, S2);
            //  u
            DeleteFile(Path);
            RenameFile(Temp, Path);
        finally
            Engine := Unassigned;
        end;
        Result := true;
    except
        on E:Exception do Err := E.Message;
    end;
end;

//  ---------------------------------------------------------------------------
//  œK
function    CompactDatabase(const Path, Pass: string; var Err: string): Boolean;
begin
    Result := ChangePassword(Path, Pass, Pass, Err);
end;

end.

